appointment/urls.py
from django.urls import path

from . import views

app_name = 'appointment'

urlpatterns = [
    path('', views.index, name='index'),
    path('buat-appointment/', views.buat_appointment, name='buat_appointment'),
    path('form-appointment/', views.form_appointment, name='form_appointment'),
    path('form-submit/', views.submit, name='submit'),
    path('delete-jadwal/', views.delete, name='delete'),
    path('update/', views.update, name='update'),
    path('update-jadwal/', views.update_form, name='update-form')
]

e6_siruco/urls.py
from django.contrib import admin
from django.urls import include, path

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('main.urls')),
    path('', include('hanif.urls')),
    path('authentication/', include('authentication.urls')),
    path('transaksi-makan/', include('transaksi_makan.urls')),
    path('paket-makan/', include('paket_makan.urls')),
    path('hotel/', include('hotel.urls')),
    path('jadwal-dokter/', include('jadwal_dokter.urls')),
    path('daftar-pasien/', include('daftar_pasien.urls')),
    path('appointment/', include('appointment.urls')),
    path('faskes/', include('faskes.urls')),
    path('jadwal_faskes/', include('jadwal_faskes.urls')),
    path('rumahsakit/', include('rumahsakit.urls')),
    path('reservasiRS/', include('reservasiRS.urls')),
    path('transaksirs/', include('transaksirs.urls')),
    path('ruangan-rs/', include('ruangan_rs.urls')),
]

main/urls.py
from django.urls import path

from . import views

app_name = 'main'

urlpatterns = [
    path('', views.home, name='home'),
]

appointment/models.py
from django.db import models

# Create your models here.

appointment/views.py
import appointment
from django.shortcuts import render, redirect
from django.db import connection
from django.db.utils import IntegrityError, InternalError
from django.contrib import messages
from datetime import datetime
import traceback

# Create your views here.
def index(request):
    with connection.cursor() as cursor:
        try:
            if request.session["peran"] == 'pengguna publik':
                print("masuk1")
                print(request.session["peran"])
                cursor.execute(f"""
                    SELECT * FROM MEMERIKSA
                    WHERE nik_pasien IN (SELECT nik FROM PASIEN WHERE idpendaftar='{request.session.get('username')}')
                """)
                memeriksa = cursor.fetchall()
                for i in range(len(memeriksa)):
                    temp = list(memeriksa[i])
                    if temp[4] == 'pertama':
                        temp[4] = 'Shift 1'
                    elif temp[4] == 'kedua':
                        temp[4] = 'Shift 2'
                    elif temp[4] == 'ketiga':
                        temp[4] = 'Shift 3'
                    elif temp[4] == 'keempat':
                        temp[4] = 'Shift 4'
                    temp[5] = datetime.strftime(temp[5], '%d-%m-%Y')
                    memeriksa[i] = temp
            elif request.session["peran"] == 'admin satgas':
                print("masuk")
                cursor.execute(f"""
                    SELECT * FROM MEMERIKSA
                """)
                memeriksa = cursor.fetchall()
                for i in range(len(memeriksa)):
                    temp = list(memeriksa[i])
                    if temp[4] == 'pertama':
                        temp[4] = 'Shift 1'
                    elif temp[4] == 'kedua':
                        temp[4] = 'Shift 2'
                    elif temp[4] == 'ketiga':
                        temp[4] = 'Shift 3'
                    elif temp[4] == 'keempat':
                        temp[4] = 'Shift 4'
                    temp[5] = datetime.strftime(temp[5], '%d-%m-%Y')
                    memeriksa[i] = temp
            elif request.session["peran"] == 'dokter':
                print("masuk")
                cursor.execute(f"""
                    SELECT * FROM MEMERIKSA
                    WHERE username_dokter='{request.session["username"]}'
                """)
                memeriksa = cursor.fetchall()
                for i in range(len(memeriksa)):
                    temp = list(memeriksa[i])
                    if temp[4] == 'pertama':
                        temp[4] = 'Shift 1'
                    elif temp[4] == 'kedua':
                        temp[4] = 'Shift 2'
                    elif temp[4] == 'ketiga':
                        temp[4] = 'Shift 3'
                    elif temp[4] == 'keempat':
                        temp[4] = 'Shift 4'
                    temp[5] = datetime.strftime(temp[5], '%d-%m-%Y')
                    memeriksa[i] = temp
            return render(request, 'appointment/index.html', {"memeriksa":memeriksa})
        except:
            traceback.print_exc()
    return render(request, 'appointment/index.html')

def buat_appointment(request):
    with connection.cursor() as cursor:
        try:
            cursor.execute(f"""
                SELECT * FROM JADWAL_DOKTER
            """)

            jadwal_dokter = cursor.fetchall()

            for i in range(len(jadwal_dokter)):
                temp = list(jadwal_dokter[i])
                if temp[3] == 'pertama':
                    temp[3] = 'Shift 1'
                elif temp[3] == 'kedua':
                    temp[3] = 'Shift 2'
                elif temp[3] == 'ketiga':
                    temp[3] = 'Shift 3'
                elif temp[3] == 'keempat':
                    temp[3] = 'Shift 4'
                temp[4] = datetime.strftime(temp[4], '%d-%m-%Y')
                jadwal_dokter[i] = temp
        except:
            traceback.print_exc()
    return render(request, 'appointment/create.html', {'jadwal_dokter':jadwal_dokter})

def form_appointment(request):
    with connection.cursor() as cursor:
        try:
            shift = ''
            if request.POST['shift'] == 'Shift 1':
                shift = 'pertama'
            elif request.POST['shift'] == 'Shift 2':
                shift = 'kedua'
            elif request.POST['shift'] == 'Shift 3':
                shift = 'ketiga'
            elif request.POST['shift'] == 'Shift 4':
                shift = 'keempat'

            if request.session.get("peran") == 'pengguna publik':
                cursor.execute(f"""
                    SELECT nik FROM PASIEN
                    WHERE idpendaftar='{request.session['username']}'
                """)
                nik_pasien = cursor.fetchall()
            elif request.session.get("peran") == 'admin satgas':
                cursor.execute(f"""
                    SELECT nik FROM PASIEN
                """)
                nik_pasien = cursor.fetchall()

            cursor.execute(f"""
                SELECT * FROM JADWAL_DOKTER
                WHERE nostr='{request.POST['nostr']}' AND username='{request.POST['username']}' AND kode_faskes='{request.POST['faskes']}'
                AND shift='{shift}' AND tanggal='{request.POST['tanggal']}'
            """)
            jadwal_dokter = cursor.fetchall()

            return render(request, 'appointment/form.html', {'nik_pasien':nik_pasien, 'jadwal_dokter':jadwal_dokter})

        except:
            traceback.print_exc()
    return render(request, 'appointment/form.html')

def submit(request):
    with connection.cursor() as cursor:
        try:
            cursor.execute(f"""
                INSERT INTO MEMERIKSA (nik_pasien, nostr, username_dokter, kode_faskes, praktek_shift, praktek_tgl) VALUES
                ('{request.POST['nik']}', '{request.POST['nostr']}', '{request.POST['username']}', 
                '{request.POST['faskes']}', '{request.POST['shift']}', '{request.POST['tanggal']}')
            """)
            return redirect('appointment:index')
        except InternalError:
            shift = ''
            if request.POST['shift'] == 'pertama':
                shift = 'Shift 1'
            elif request.POST['shift'] == 'kedua':
                shift = 'Shift 2'
            elif request.POST['shift'] == 'ketiga':
                shift = 'Shift 3'
            elif request.POST['shift'] == 'keempat':
                shift = 'Shift 4'
            tanggal = datetime.strptime(request.POST['tanggal'], '%b %d, %Y')
            tanggal = datetime.strftime(tanggal, '%d-%m-%Y')
            traceback.print_exc()
            messages.add_message(request, messages.WARNING, f"""Silahkan pilih shift dan tanggal lainnya,
                karena shift dan tanggal yang dipilih sudah penuh""")
            return buat_appointment(request)

def delete(request):
    if request.sesssion.get('peran') != 'admin satgas':
        return redirect('main:home')
    else:
        with connection.cursor() as cursor:
            try:
                shift = ''
                if request.POST['shift'] == 'Shift 1':
                    shift = 'pertama'
                elif request.POST['shift'] == 'Shift 2':
                    shift = 'kedua'
                elif request.POST['shift'] == 'Shift 3':
                    shift = 'ketiga'
                elif request.POST['shift'] == 'Shift 4':
                    shift = 'keempat'
                cursor.execute(f"""
                    DELETE FROM MEMERIKSA
                    WHERE nik_pasien='{request.POST['nik']}' AND username_dokter='{request.POST['username']}'
                    AND kode_faskes='{request.POST['faskes']}' AND praktek_shift='{shift}'
                    AND praktek_tgl='{request.POST['tanggal']}'
                """)
            except:
                traceback.print_exc()
                messages.add_message(request, messages.WARNING, f"""Ada gangguan server, harap coba lagi""")
        return redirect('appointment:index')

def update(request):
    if request.method == 'POST':
        with connection.cursor() as cursor:
            try:
                tanggal = datetime.strptime(request.POST['tanggal'], '%b %d, %Y')
                tanggal = datetime.strftime(tanggal, '%d-%m-%Y')
                cursor.execute(f"""
                    UPDATE MEMERIKSA
                    SET rekomendasi='{request.POST['rekomendasi']}'
                    WHERE nik_pasien='{request.POST['nik']}' AND username_dokter='{request.POST['username']}'
                    AND kode_faskes='{request.POST['faskes']}' AND praktek_shift='{request.POST['shift']}'
                    AND praktek_tgl='{tanggal}'
                """)
            except:
                traceback.print_exc()
    
    return redirect('appointment:index')


def update_form(request):
    with connection.cursor() as cursor:
        try:
            shift = ''
            if request.POST['shift'] == 'Shift 1':
                shift = 'pertama'
            elif request.POST['shift'] == 'Shift 2':
                shift = 'kedua'
            elif request.POST['shift'] == 'Shift 3':
                shift = 'ketiga'
            elif request.POST['shift'] == 'Shift 4':
                shift = 'keempat'
            cursor.execute(f"""
                SELECT * FROM MEMERIKSA
                WHERE nik_pasien='{request.POST['nik']}' AND username_dokter='{request.POST['username']}'
                AND kode_faskes='{request.POST['faskes']}' AND praktek_shift='{shift}'
                AND praktek_tgl='{request.POST['tanggal']}'
            """)
            memeriksa = cursor.fetchall()
        except:
            traceback.print_exc()
    
    return render(request, 'appointment/update-form.html', {'memeriksa':memeriksa})

appointment/templates/appointment/create.html
{% extends 'base.html' %}

{% block content %}
{% if request.session.peran == 'pengguna publik' or request.session.peran == 'admin satgas' %}
<div class="container">
    <div class="table-responsive">
        <table class="table caption-top">
            {% for message in messages %}
            <caption>{{ message }}</caption>
            {% endfor %}
            <thead>
                <tr>
                    <th scope="col">No</th>
                    <th>No STR</th>
                    <th>Username</th>
                    <th>Faskes</th>
                    <th>Shift</th>
                    <th>Tanggal</th>
                    <th>Buat Appointment</th>
                </tr>
            </thead>
            <tbody>
            {% for jadwal in jadwal_dokter %}
            <tr>
                <form action="{% url 'appointment:form_appointment' %}" method="POST">
                    {% csrf_token %}
                    <td>{{ forloop.counter }}.</td>
                    <td><input name="nostr" value="{{ jadwal.0 }}" style="display: none;" readonly></input>{{ jadwal.0 }}</td>
                    <td><input name="username" value="{{ jadwal.1 }}" style="display: none;" readonly></input>{{ jadwal.1 }}</td>
                    <td><input name="faskes" value="{{ jadwal.2 }}" style="display: none;" readonly></input>{{ jadwal.2 }}</td>
                    <td><input name="shift" value="{{ jadwal.3 }}" style="display: none;" readonly></input>{{ jadwal.3 }}</td>
                    <td><input name="tanggal" value="{{ jadwal.4 }}" style="display: none;" readonly></input>{{ jadwal.4 }}</td>
                    <td><button type="submit" class="btn btn-outline-success">Book</button></td>
                </form>
            </tr>
            {% endfor %}
            </tbody>
        </table>
    </div>
</div>
{% endif %}
{% endblock content %}

appointment/templates/appointment/form.html
{% extends 'base.html' %}

{% block content %}
{% if request.session.peran == 'pengguna publik' or request.session.peran == 'admin satgas' %}
<div class="container">
    <div class="row"></div>
    <div class="row align-items-center">
        <div class="col"></div>
        <div class="col-6">
            <form method="POST" class="" action="{% url 'appointment:submit' %}">
                {% csrf_token %}
                <figure class="text-center">
                    <h3>Siruco - Buat Appointment</h3>
                </figure>

                <div class="mb-3">
                    <label for="nik-pasien" class"form-label">NIK Pasien</label>
                    <select class="form-select" name="nik" aria-label="Default select example" id='nik-pasien'
                    oninvalid="this.setCustomValidity('Data yang diisikan belum lengkap, silahkan lengkapi data terlebih dahulu')" 
                    oninput="this.setCustomValidity('')" required>
                        <option value="">Pasien</option>
                        {% for nik in nik_pasien %}
                        <option value="{{nik.0}}">{{ nik.0 }}</option>
                        {% endfor %}
                    </select>
                </div>

                {% for jadwal in jadwal_dokter %}
                <div class="mb-3">
                    <label for="username" class"form-label">Username Dokter</label>
                    <input type="text" class="form-control" name="username" id="username" value="{{ jadwal.1 }}" readonly></input>
                </div>

                <div class="mb-3">
                    <label for="faskes" class"form-label">Faskes</label>
                    <input type="text" class="form-control" name="faskes" id="faskes" value="{{ jadwal.2 }}" readonly></input>
                </div>

                <div class="mb-3">
                    <label for="tanggal" class"form-label">Tanggal Praktek</label>
                    <input type="text" class="form-control" name="tanggal" id="tanggal" value="{{ jadwal.4 }}" readonly></input>
                </div>

                <div class="mb-3">
                    <label for="shift" class"form-label">Shift Praktek</label>
                    <input type="text" class="form-control" name="shift" id="shift" value="{{ jadwal.3 }}" readonly></input>
                </div>

                <div class="mb-3">
                    <input type="hidden" class="form-control" name="nostr" id="nostr" value="{{ jadwal.0 }}" readonly></input>
                </div>
                {% endfor %}

                <figure class="text-center">
                    {% for message in messages %}
                    {{ message }}
                    <br>
                    {% endfor %}

                    <button type="submit" class="btn btn-outline-success">Simpan</button>
                </figure>
            </form>
        </div>
        <div class="col"></div>
    </div>
</div>
{% endif %}
{% endblock content %}

appointment/templates/appointment/index.html
{% extends 'base.html' %}

{% block content %}
<div class="container">
    <div class="table-responsive">
        {% if request.session.peran == 'dokter' %}
        <table class="table">
            <thead>
                <tr>
                    <th scope="col">No</th>
                    <th>NIK</th>
                    <th>Username</th>
                    <th>Faskes</th>
                    <th>Shift</th>
                    <th>Tanggal</th>
                    <th>Rekomendasi</th>
                    <th>Update Appointment</th>
                </tr>
            </thead>
            <tbody>
            {% for jadwal in memeriksa %}
            <tr>
                <form action="{% url 'appointment:update-form' %}" method="POST">
                    {% csrf_token %}
                    <td>{{ forloop.counter }}.</td>
                    <td><input type="hidden" name="nik" value="{{ jadwal.0 }}" readonly></input>{{ jadwal.0 }}</td>
                    <td><input type="hidden" name="username" value="{{ jadwal.2 }}" readonly></input>{{ jadwal.2 }}</td>
                    <td><input type="hidden" name="faskes" value="{{ jadwal.3 }}" readonly></input>{{ jadwal.3 }}</td>
                    <td><input type="hidden" name="shift" value="{{ jadwal.4 }}" readonly></input>{{ jadwal.4 }}</td>
                    <td><input type="hidden" name="tanggal" value="{{ jadwal.5 }}" readonly></input>{{ jadwal.5 }}</td>
                    <td><input type="hidden" name="rekomendasi" value="{{ jadwal.6 }}" readonly></input>{{ jadwal.6 }}</td>
                    <input type="hidden" name="nostr" value="{{ jadwal.1 }}" readonly></input>
                    <td><button type="submit" class="btn btn-outline-primary">Update</button></td>
                </form>
            </tr>
            {% endfor %}
            </tbody>
        </table>

        {% elif request.session.peran == 'pengguna publik' %}
        <table class="table">
            <thead>
                <tr>
                    <th scope="col">No</th>
                    <th>NIK</th>
                    <th>Username</th>
                    <th>Faskes</th>
                    <th>Shift</th>
                    <th>Tanggal</th>
                    <th>Rekomendasi</th>
                </tr>
            </thead>
            <tbody>
            {% for jadwal in memeriksa %}
            <tr>
                <form action="#" method="POST">
                    {% csrf_token %}
                    <td>{{ forloop.counter }}.</td>
                    <td><input type="hidden" name="nik" value="{{ jadwal.0 }}" readonly></input>{{ jadwal.0 }}</td>
                    <td><input type="hidden" name="username" value="{{ jadwal.2 }}" readonly></input>{{ jadwal.2 }}</td>
                    <td><input type="hidden" name="faskes" value="{{ jadwal.3 }}" readonly></input>{{ jadwal.3 }}</td>
                    <td><input type="hidden" name="shift" value="{{ jadwal.4 }}" readonly></input>{{ jadwal.4 }}</td>
                    <td><input type="hidden" name="tanggal" value="{{ jadwal.5 }}" readonly></input>{{ jadwal.5 }}</td>
                    <td><input type="hidden" name="rekomendasi" value="{{ jadwal.6 }}" readonly></input>{{ jadwal.6 }}</td>
                    <input type="hidden" name="nostr" value="{{ jadwal.1 }}" readonly></input>
                </form>
            </tr>
            {% endfor %}
            </tbody>
        </table>

        {% elif request.session.peran == 'admin satgas' %}
        <table class="table">
            <thead>
                <tr>
                    <th scope="col">No</th>
                    <th>NIK</th>
                    <th>Username</th>
                    <th>Faskes</th>
                    <th>Shift</th>
                    <th>Tanggal</th>
                    <th>Rekomendasi</th>
                    <th>Delete Appointment</th>
                </tr>
            </thead>
            <tbody>
            {% for jadwal in memeriksa %}
            <tr>
                <form action="{% url 'appointment:delete' %}" method="POST">
                    {% csrf_token %}
                    <td>{{ forloop.counter }}.</td>
                    <td><input type="hidden" name="nik" value="{{ jadwal.0 }}" readonly></input>{{ jadwal.0 }}</td>
                    <td><input type="hidden" name="username" value="{{ jadwal.2 }}" readonly></input>{{ jadwal.2 }}</td>
                    <td><input type="hidden" name="faskes" value="{{ jadwal.3 }}" readonly></input>{{ jadwal.3 }}</td>
                    <td><input type="hidden" name="shift" value="{{ jadwal.4 }}" readonly></input>{{ jadwal.4 }}</td>
                    <td><input type="hidden" name="tanggal" value="{{ jadwal.5 }}" readonly></input>{{ jadwal.5 }}</td>
                    <td><input type="hidden" name="rekomendasi" value="{{ jadwal.6 }}" readonly></input>{{ jadwal.6 }}</td>
                    <input type="hidden" name="nostr" value="{{ jadwal.1 }}" readonly></input>
                    <td><button type="submit" class="btn btn-outline-danger">Delete</button></td>
                </form>
            </tr>
            {% endfor %}
            </tbody>
        </table>
        {% endif %}
    </div>
</div>
{% endblock content %}

appointment/templates/appointment/update-form.html
{% extends 'base.html' %}

{% block content %}
{% if request.session.peran == 'dokter' %}
<div class="container">
    <div class="row"></div>
    <div class="row align-items-center">
        <div class="col"></div>
        <div class="col-6">
            <form method="POST" class="" action="{% url 'appointment:update' %}">
                {% csrf_token %}
                <figure class="text-center">
                    <h3>Siruco - Update Appointment</h3>
                </figure>

                {% for jadwal in memeriksa %}
                <div class="mb-3">
                    <label for="nik" class"form-label">NIK</label>
                    <input type="text" class="form-control" name="nik" id="username" value="{{ jadwal.0 }}" readonly></input>
                </div>

                <div class="mb-3">
                    <label for="username" class"form-label">Username Dokter</label>
                    <input type="text" class="form-control" name="username" id="username" value="{{ jadwal.2}}" readonly></input>
                </div>

                <div class="mb-3">
                    <label for="shift" class"form-label">Shift Praktek</label>
                    <input type="text" class="form-control" name="shift" id="shift" value="{{ jadwal.4 }}" readonly></input>
                </div>

                <div class="mb-3">
                    <label for="tanggal" class"form-label">Tanggal Praktek</label>
                    <input type="text" class="form-control" name="tanggal" id="tanggal" value="{{ jadwal.5 }}" readonly></input>
                </div>

                <div class="mb-3">
                    <label for="faskes" class"form-label">Faskes</label>
                    <input type="text" class="form-control" name="faskes" id="faskes" value="{{ jadwal.3}}" readonly></input>
                </div>

                <div class="mb-3">
                    <label for="rekomendasi" class"form-label">Rekomendasi</label>
                    <input type="text" class="form-control" name="rekomendasi" id="rekomendasi" value="{{ jadwal.6 }}" placeholder="Rekomendasi" 
                    oninvalid="this.setCustomValidity('Data yang diisikan belum lengkap, silahkan lengkapi data terlebih dahulu')" oninput="this.setCustomValidity('')" required></input>
                </div>

                <div class="mb-3">
                    <input type="hidden" class="form-control" name="nostr" id="nostr" value="{{ jadwal.1 }}" readonly></input>
                </div>
                {% endfor %}

                <figure class="text-center">
                    {% for message in messages %}
                    {{ message }}
                    <br>
                    {% endfor %}

                    <button type="submit" class="btn btn-outline-success">Simpan</button>
                </figure>
            </form>
        </div>
        <div class="col"></div>
    </div>
</div>
{% endif %}
{% endblock content %}